// Dune
//
// Judge Library
#include <string>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <sstream>
#include "../ojcontrol_ext.h"
using namespace std;

static const int MaxN = 101;
static const int MaxM = 4001;

static int n, m, nowpos, nowroad; //, Count, score;
static bool stone;
static bool havestone[MaxN];
static int g[MaxN][MaxM], h[MaxN][MaxM];
static int d[MaxN];

void init(FILE *fin)
{
    fscanf(fin, "%d%d", &n, &m);
    m = 0;
    int i, j, k;
    for (i = 1; i <= n; i++) {
        fscanf(fin, "%d", &d[i]);
        m += d[i];
        for (j = 0; j < d[i]; j++) {
            fscanf(fin, "%d", &g[i][j]);
        }
    }
    m /= 2;
    for (i = 1; i <= n; i++) {
        for (j = 0; j < d[i]; j++) {
            for (k = 0; k < d[g[i][j]]; k++) {
                if (g[g[i][j]][k] == i) break;
            }
            h[i][j] = k;
        }
    }
    nowpos = 1;
    nowroad = 0;
    stone = true;
    memset(havestone, 0, sizeof(havestone));
}

int main(int argc, char* argv[]) {
  string filename = "dune.in";
  init_server(argc, argv, filename);

  FILE* fin = fopen(filename.c_str(), "r");
  int correct = 1;

  int T;
  fscanf(fin, "%d", &T);
  writeline(T);

  while(T--) {
    init(fin);

    bool ok = false;
    string s, cmd;
    int cnt = 0;
    for(;;) {
      if(!readline(s)) break;
      stringstream ss(s);
      ss >> cmd;
      if(cmd == "Look") {
        stringstream ss2;
        ss2 << d[nowpos] << " " << havestone[nowpos];
        writeline(ss2.str());
      }
      else if(cmd == "Walk") {
        int k;
        if(!(ss >> k)) PV("bad format"); // bad format
        int nextpos = g[nowpos][(nowroad + k) % d[nowpos]];
        nowroad = h[nowpos][(nowroad + k) % d[nowpos]];
        nowpos = nextpos;
        if(++cnt > 65536) PLE("Too many walks");
      }
      else if(cmd == "Put") {
        if (!stone) PV("You don't have the token");
        stone = false;
        havestone[nowpos] = true;
      }
      else if(cmd == "Take") {
        if (!havestone[nowpos]) PV("Current cave doesn't have the token.");
        stone = true;
        havestone[nowpos] = false;
      }
      else if(cmd == "Answer") {
        int nn, mm;
        if(!(ss >> nn >> mm)) PV("bad format");
        if(n != nn) WA("Incorrect n");
        if(m != mm) WA("Incorrect m");
        ok = true;
        cerr << "Solved in " << cnt << " walks\n";
        break;
      }
      else PV("no such command"); // invalid command
    }
    if(!ok) {
      correct = 0;
      break; // no need to give more tests
    } 
  }
  fclose(fin);

  if(correct) cerr << "Correct\n";

  return 0;
}
