// InteractLib - a small library for ACM/ICPC interactive problems
// by Rujia Liu
//
// Usage:
//   Include this file in your program, and use -I<directory_of_libexecstream> in your compile command-line.
//   When you include this file, you automatically get a new pair of cin/cout to interact with your child process.
//   Don't forget to call interactlib::open_child(prog, args) at the beginning of your main()!

#include <exec-stream.cpp> // This library uses libexecstream

#define cin  (interactlib::es.out())
#define cout (interactlib::es.in())

namespace interactlib {

  exec_stream_t es;

  inline void open_child(const std::string& prog, const std::string& args){
    es.start(prog, " " + args);
  }

}
