#include<cstdio>
#include<cstdlib>
#include<vector>
#include<cassert>
using namespace std;

const int maxn = 10000;

void AC() { exit(0); }
void WA() { exit(2); }

bool check_solution(int t1, int t2, int t3, int mm, int gg, FILE* fp, int& ans) {
  char s[maxn], temp1[maxn], temp2[maxn];
//  printf("%d %d %d %d %d\n", t1, t2, t3, mm, gg);

  if(fgets(s, maxn, fp) == NULL) {
      printf("Unexpected EOF\n");
      return false;
  }
  if(sscanf(s, "%s%s%d", temp1, temp2, &ans) != 3) {
    printf("Invalid solution header. Expected 'Case xxx: xxx'\n");
    return false;
  }

  int last_t = 0, t, id, cmd, zero, base_ready = 0, m = 50, g = 0;

  vector<int> scv;
  scv.push_back(0);
  scv.push_back(0);
  scv.push_back(0);
  scv.push_back(0);

  for(;;) {
    if(fgets(s, maxn, fp) == NULL) break;
    if(s[0] == '\0' || s[0] == '\r' || s[0] == '\n') break;

//    printf("- %s\n", s);

    if(sscanf(s, "%d%d%d", &t, &id, &cmd) == 3) {
      if(t < last_t) {
        printf("Time is not in accending order: %d\n", t);
        return false;
      }
      id--;
      if(id >= scv.size()) {
        printf("[%d] scv id out of range: %d\n", t, id+1);
        return false;
      }
      if(t < scv[id]) {
        printf("[%d] scv %d is not ready until %d\n", t, id+1, scv[id]);
        return false;
      }
      if(cmd == 1) {
        m += 8; 
        scv[id] += t1;
      } else if(cmd == 2) {
        g += 8; 
        scv[id] += t2;
      } else {
        printf("[%d] invalid operation: %d\n", t, cmd);
        return false;
      }
    }
    else if(sscanf(s, "%d%d", &t, &zero) == 2) {
      if(t < last_t) {
        printf("Time is not in accending order: %d\n", t);
        return false;
      }
      if(zero != 0) {
        printf("type-2 command must be <time> 0\n");
        return false;
      }
      if(m < 50) {
        printf("[%d] not enough minerals to build scv\n", t);
        return false;
      }
      if(t < base_ready) {
        printf("[%d] not ready to build scv until %d\n", t, base_ready);
        return false;
      }
      m -= 50;
      scv.push_back(t + t3);
      base_ready = t + t3;
    }
    else {
      printf("Invalid command format\n");
      return false;
    }

    last_t = t;
  }

  for(int i = 0; i < scv.size(); i++)
    if(ans < scv[i]) {
      printf("scv %d is not ready after time %d\n", i+1, ans);
      return false;
    }

  if(m < mm) {
    printf("Not enough minerals. Got %d, expected %d\n", m, mm);
    return false;
  }

  if(g < gg) {
    printf("Not enough gas. Got %d, expected %d\n", g, gg);
    return false;
  }

  return true;
}

void check(FILE* fin, FILE* fans, FILE* fout) {
  int t1, t2, t3, m, g, t_ans, t_out;
  for(int kase = 1; ; kase++) {
    if(fscanf(fin, "%d%d%d%d%d", &t1, &t2, &t3, &m, &g) != 5) break;
    if(!t1 && !t2 && !t3 && !m && !g) break;
    printf("Case %d...\n", kase);
    assert(check_solution(t1, t2, t3, m, g, fans, t_ans));
    if(!check_solution(t1, t2, t3, m, g, fout, t_out)) WA();
    if(t_ans != t_out) {
      printf("Expected %d, got %d\n", t_ans, t_out);
      WA();
    }
  }
  printf("Correct!\n");
  AC();
}

int main(int argc, char* argv[]) {
  FILE *fin = fopen(argv[1], "r");
  FILE *fans = fopen(argv[2], "r");
  check(fin, fans, stdin);
  fclose(fin);
  fclose(fans);
  return 0;
}
