#include<iostream>
#include<cstdlib>
using namespace std;

#ifdef AUTO_MODE
#include <interactlib.h>
#endif

void writeline(const std::string& s) {
#ifdef DEBUG
  cerr << "--> " << s << "\n";
#endif
  cout << s << "\n" << flush;
}

bool readline(std::string& s) {
  if(!getline(cin, s).good()) return false;
#ifdef DEBUG
  cerr << "<-- " << s << "\n";
#endif
  return true;
}

void writeline(int x) {
#ifdef DEBUG
  cerr << "--> " << x << "\n";
#endif
  cout << x << "\n" << flush;
}

void WA(const char* msg) {
  cerr << "Wrong Answer: " << msg << "\n";
  exit(0);
}

void BC() {
  cerr << "Broken Communication\n";
  exit(0);
}

void PV(const char* msg) {
  cerr << "Protocol violation: " << msg << "\n";
  exit(0);
}

void PLE(const char* msg) {
  cerr << "Protocol Limit Exceeded: " << msg << "\n";
  exit(0);
}

// server <inputfile> <prog> <arguments>
void init_server(int argc, char* argv[], std::string& filename) {
  if(argc > 1) filename = argv[1];
#ifdef AUTO_MODE
  if(argc <= 2)
    interactlib::open_child("./client", "");
  else if(argc == 3)
    interactlib::open_child(argv[2], "");
  else
    interactlib::open_child(argv[2], argv[3]);
#endif
}
