// Mysterious Space Station
//
// Judge Library
// written by Rujia Liu in 2002
// adapted by Rujia Liu in 2014

#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<sstream>
#include<iostream>
#include "../ojcontrol_ext.h"
using namespace std;

#define MAXN 20

int k,answered;
int pos;
int link[MAXN*MAXN+1];
int number[MAXN*MAXN+1][5];

bool Init(FILE* inf)
{
  int dx[5]={0,-1,0,1,0};
  int dy[5]={0,0,1,0,-1};
  int n,m,c=0,i,j,d;
  char row[MAXN+1];
  int no[MAXN+1][MAXN+1];
  int first[6];
  answered=0;
  memset(no,0,sizeof(no));
  memset(first,0,sizeof(first));
  memset(link,0,sizeof(link));
  memset(number,0,sizeof(number));

  if(fscanf(inf,"%d%d%d",&n,&m,&k) != 3) return false;
  cout << n << " " << m << " " << k << "\n" << flush;
  if(!n) return false;

  for(i=1;i<=n;i++){
    fscanf(inf, "%s", row);
    for(j=1;j<=m;j++){
      char&ch=row[j-1];
      if(ch>='1'&&ch<='5'){
        if (first[ch-'0']==0) first[ch-'0']=c+1;
        else{
          link[c+1]=first[ch-'0'];
          link[first[ch-'0']]=c+1;
        }
        ch='.';
      }
      if(ch=='S') pos=c+1;
      if(ch=='.' || ch=='S') no[i][j]=++c;
    }
    cout << row << "\n" << flush;
  }

  for(i=1;i<=n;i++)
    for(j=1;j<=m;j++)
      if(no[i][j]>0)
        for(d=1;d<=4;d++)
          number[no[i][j]][d]=no[i+dx[d]][j+dy[d]];

  for(i=1;i<=c;i++)
    for(d=1;d<=4;d++)
      if(link[number[i][d]]>0)
        number[i][d]=number[link[number[i][d]]][d];
  return true;
}

int MoveRobot(char Direction)
{
  int d;
  switch(Direction){
    case 'N': d=1; break;
    case 'E': d=2; break;
    case 'S': d=3; break;
    case 'W': d=4; break;
    otherwise: return -1; // error
  }
  if(number[pos][d]>0)
  {
    pos=number[pos][d];
    return 1;
  }
  else return 0;
}

int Answer(int pos1, int pos2)
{
  if(link[pos1]!=pos2) return -1; // wrong
  link[pos1]=0;
  link[pos2]=0;
  answered++;
  if (answered==k) return 1; // solved
  return 0; // continue
}

int main(int argc, char* argv[]) {
  string filename = "station.in";
  init_server(argc, argv, filename);

  FILE* fin = fopen(filename.c_str(), "r");
  int correct = 1;

  while(Init(fin)) {
    bool ok = false;
    string s, cmd;
    int cnt = 0;
    for(;;) {
      if(!readline(s)) BC();
      stringstream ss(s);
      if(!(ss >> cmd)) PV("empty command");
      if(cmd == "MoveRobot") {
        string dir;
        if(!(ss >> dir)) PV("bad format"); // bad format
        if(++cnt > 32767) PLE("too many commands"); // too many commands
        int ret = MoveRobot(dir[0]);
        if(ret < 0) PV("bad format"); // error in MoveRobot
        writeline(ret);
      }
      else if(cmd == "Answer") {
        int a, b;
        if(!(ss >> a >> b)) PV("bad format"); // bad format
        int ret = Answer(a, b);
        if(ret < 0) WA("incorrect answer"); // wrong
        if(ret == 1) {
          ok = true;
          cerr << "Solved in " << cnt << " commands\n";
          break;
        }
      }
      else PV("so such command"); // invalid command
    }
    if(!ok) {
      correct = 0;
      break; // no need to give more tests
    } 
  }
  fclose(fin);

  if(correct) cerr << "Correct\n";

  return 0;
}
