#include<cstdio>
#include<cstring>
#include<vector>
#include<cstdlib>
#include<queue>
#include<set>
#include<iostream>
#include<sstream>
#include "../ojcontrol_ext.h"
using namespace std;

const int maxt = 100;
const int maxj = 98765; // 98765
int cnt[maxt + 5], tot;
vector<int> tribe_no;
multiset<pair<int, int> > counts;

int dangerous() {
  if(tot == 0) return 0;
  pair<int,int> p = *(--counts.end());
  int c = p.first;
  if(c <= tot-c) return 0;
  return p.second;
}

void inc(int tribe) {
  int c = cnt[tribe];
  cnt[tribe]++;
  if(c > 0) counts.erase(make_pair(c, tribe));
  counts.insert(make_pair(c+1, tribe));
  tot++;
}

void dec(int tribe) {
  int c = cnt[tribe];
  cnt[tribe]--;
  counts.erase(make_pair(c, tribe));
  if(c-1 > 0) counts.insert(make_pair(c-1, tribe));
  tot--;
}

int main(int argc, char* argv[]) {
  string filename = "stone.in";
  init_server(argc, argv, filename);

  FILE* fin = fopen(filename.c_str(), "r");

  int n, tribe;
  fscanf(fin, "%d", &n);
  while(n--) {
    fscanf(fin, "%d", &tribe);
    tribe_no.push_back(tribe);
  }

  int entered = 0, need_answer = 0, counter = 0, i, j;
  bool correct = false;
  string s, cmd;
  tot = 0;
  for(;;) {
    if(!readline(s)) BC();
    stringstream ss(s);
    if(!(ss >> cmd)) PV("empty command");
    if(cmd == "Getjob") {
      if(need_answer) PV("You shoud answer immediately"); // should answer!

      fscanf(fin, "%d", &j);
      writeline(j);
      if(j == 0) { counter = 0; inc(tribe_no[entered++]); }
      else if(j > 0) { counter = 0; dec(tribe_no[j-1]); }
      else if(j == -1) need_answer = 1;
      else if(j == -2) { correct = true; break; }
    }
    else if(cmd == "Query") {
      if(need_answer) PV("You shoud answer immediately"); // should answer!
      if(!(ss >> i >> j)) PV("bad format"); // bad format
      if(!(i >= 1 && i <= entered && j >= 1 && j <= entered)) PV("argument out of range"); // out of range

      if(++counter > 5) PLE("Too many queries after a new event"); // too many queries
      if(tribe_no[i-1] == tribe_no[j-1]) writeline(1); else writeline(0);
    } else if(cmd == "Answer") {
      if(!(ss >> i)) PV("bad format"); // bad format
      if(!(i >= 0 && i <= entered)) PV("argument out of range"); // out of range
      if(!need_answer) PV("nothing to answer"); // nothing to answer
      int ans = dangerous();
      if(!((ans == 0 && i == 0) || (i > 0 && ans == tribe_no[i-1]))) PV("wrong answer"); // wrong
      need_answer = 0;
    }
    else PV("no such command");
  }

  fclose(fin);

  if(correct) cerr << "Correct\n";

  return 0;
}
