#include<cstdio>
#include<vector>
#include<sstream>
#include<iostream>
#include "../ojcontrol_ext.h"
using namespace std;

void writeline(int x, int y) {
  stringstream ss;
  ss << x << " " << y;
  writeline(ss.str());
}

int main(int argc, char* argv[]) {
  string filename = "team.in";
  init_server(argc, argv, filename);

  FILE* fin = fopen(filename.c_str(), "r");
  int correct = 1;

  int T, n, m, team[999], cnt[999], asked[999];
  fscanf(fin, "%d", &T);
  writeline(T);
  while(T--) {
    fscanf(fin, "%d%d", &n, &m);
    writeline(n, m);
    for(int i = 1; i <= n+m+1; i++) {
      fscanf(fin, "%d", &team[i]);
      cnt[i] = 0;
    }

    bool ok = false;
    string s, cmd;
    bool judge_truth = true;
    for(;;) {
      if(!readline(s)) BC();
      stringstream ss(s);
      if(!(ss >> cmd)) PV("empty command");
      if(cmd == "Ask") {
        int c1, c2, t;
        if(!(ss >> c1 >> c2 >> t)) PV("bad format");
        if(t != 0 && t != 1) PV("invalid t"); // invalid argument
        if(!(c1 >= 1 && c1 <= n+m+1) || !(c2 >= 1 && c2 <= n+m+1)) PV("invalid c1 or c2"); // invalid c1 or c2
        if(c1 == c2) PV("can't ask about self"); // can't ask about self
        if(++cnt[c1] > 2) PLE("too many questions"); // too many questions
        if(cnt[c1] == 2 && c2 == asked[c1]) PV("asking the same kid about the same kid twice"); // ask twice
        asked[c1] = c2;

        int ans = (team[c2] == t ? 1 : 0);
        if(team[c1] == 0) writeline(ans);
        else if(team[c1] == 1) writeline(1-ans);
        else {
          if(judge_truth) writeline(ans); else writeline(1-ans);
          judge_truth = !judge_truth;
        }
      }
      else if(cmd == "Answer") {
        bool bad1 = false, bad2 = false;
        for(int i = 1; i <= n+m+1 && !bad1; i++) {
          int x;
          if(!(ss >> x)) bad1 = true;
          else if(x != team[i]) bad2 = true;
        }
        if(bad1) PV("bad format");
        if(bad2) WA("Incorrect answer");
        ok = true;
        break;
      }
      else PV("no such command"); // invalid command
    }
    if(!ok) {
      correct = 0;
      break; // no need to give more tests
    } 
  }
  fclose(fin);

  if(correct) cerr << "Correct\n";

  return 0;
}
