// Xmas Gift
//
// Judge Library
// written by Rujia Liu in 2003
// adapted by Rujia Liu in 2014
#include<cstdio>
#include<cstdlib>
#include<iostream>
#include<sstream>
#include<cassert>
#include "../ojcontrol_ext.h"
using namespace std;

const int maxn = 100000 + 5;
int n, rot, discA[maxn];

int main(int argc, char* argv[]) {
  string filename = "xmas.in";
  init_server(argc, argv, filename);

  FILE* fin = fopen(filename.c_str(), "r");
  int correct = 1;

  int T;
  fscanf(fin, "%d", &T);
  writeline(T);

  while(T--) {
    fscanf(fin, "%d%d", &n, &rot);
    for(int i = 0; i < n; i++)
      fscanf(fin, "%d", &discA[i]);
    writeline(n);
    cout << discA[0];
    for(int i = 1; i < n; i++)
      cout << " " << discA[i];
    cout << "\n" << flush;

    bool ok = false;
    string s, cmd;
    int cnt = 0;
    for(;;) {
      if(!readline(s)) BC();
      stringstream ss(s);
      if(!(ss >> cmd)) PV("empty command");
      if(cmd == "Rotate") {
        int k;
        if(!(ss >> k)) PV("bad format"); // bad format
        rot = (rot + k) % n;
      }
      else if(cmd == "Drop") {
        if(++cnt > 5) PLE("too many drops"); // too many commands
        int ans = -n;
        for(int i = 0; i < n; i++){
          int v = discA[i] - discA[(i - rot + n) % n];
          if(v > ans) ans = v;
        }
        writeline(ans);
        if(ans == 0) {
          ok = true;
          cerr << "Solved in " << cnt << " drops\n";
          break;
        }
      }
      else PV("no such command"); // invalid command
    }
    if(!ok) {
      correct = 0;
      break; // no need to give more tests
    } 
  }
  fclose(fin);

  if(correct) cerr << "Correct\n";

  return 0;
}
